﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Toyota.Common.Web.Html.Helper;
@model Toyota.Common.Web.MVC.ModelHolder
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

<style type="text/css">
    .dxgvInlineEditRow_IPPCSBlue td.dxgv {
        border-bottom: 1px solid #4f93e3;
        border-right: 1px solid #4f93e3;
        background: none;
    }
</Style>

<script type="text/javascript">
    //---=== Global vars
    var buttonAction = '';
    var globalTaxCd = '';

    //---=== Callback
    function GridCompPriceRateBeginCallback(s, e) {
        e.customArgs["CompPriceCd"] = grlCompPrice.GetValue();
        e.customArgs["ConditionRule"] = txtConditionRule.GetText();
        e.customArgs["TaxCd"] = grlTax.GetValue();
    }

    function GridCompPriceRateEndCallback(s, e) {
        if (buttonAction == 'N') {
            GridgrlCompPriceOnGrid.UnselectRows();
            GridgrlTaxOnGrid.UnselectRows();
        }
        if (buttonAction == 'U') {
            GridgrlTaxOnGrid.UnselectRows();
            grlTaxOnGrid.SetValue(globalTaxCd);
        }
    }
    //---=== End callback

    //---=== Button action
    function btnSearch_click(s, e) {
        //---=== Validation
        if (((grlCompPrice.GetValue() == null) || (grlCompPrice.GetValue() == ''))
                && (txtConditionRule.GetText() == '')
                && ((grlTax.GetValue() == null) || (grlTax.GetValue() == ''))) {
            $.msgBox({
                title: "Warning",
                content: "Please select one or more parameter search !"
            });
        } else {
            GridCompPriceRate.PerformCallback();
        }
    }

    function btnClear_click(s, e) {
        grlCompPrice.SetValue('');
        grlTax.SetValue('');
        txtConditionRule.SetText('');
        GridCompPriceRate.PerformCallback();

        GridgrlCompPrice.UnselectRows();
        GridgrlTax.UnselectRows();
    }

    function btnNewClick(s, e) {
        //---=== Enable button
        btnSave.SetEnabled(true);
        btnCancel.SetEnabled(true);
        //---=== Disable button
        btnSearch.SetEnabled(false);
        btnClear.SetEnabled(false);
        btnNew.SetEnabled(false);
        btnEdit.SetEnabled(false);
        btnDelete.SetEnabled(false);
        //---=== Open editor
        buttonAction = 'N';
        GridCompPriceRate.AddNewRow();
    }

    function btnEditClick(s, e) {
        GlobalSelectedKey = GridCompPriceRate.GetSelectedKeysOnPage();
     
        if(GlobalSelectedKey.length == 0 || GlobalSelectedKey.length > 1) {
            $.msgBox({
                    title: "Warning",
                    content: "Please select just one row to edit!"
            });
            return;
        }

        if(GlobalSelectedKey.length == 1) {
            //---=== Enable button
            btnSave.SetEnabled(true);
            btnCancel.SetEnabled(true);
            //---=== Disable button
            btnSearch.SetEnabled(false);
            btnClear.SetEnabled(false);
            btnNew.SetEnabled(false);
            btnEdit.SetEnabled(false);
            btnDelete.SetEnabled(false);
            //---=== Open editor
            globalTaxCd = GlobalSelectedKey[0].split('|')[1];
            buttonAction = 'U';
            GridCompPriceRate.StartEditRowByKey(GlobalSelectedKey);
        }
    }

    function btnDeleteClick(s, e) {
        GlobalSelectedKey = GridCompPriceRate.GetSelectedKeysOnPage();
        if(GlobalSelectedKey.length == 0) {
            $.msgBox({
                title: "Warning",
                content: "Please select data to delete."
                });
            return;
        } else {               
            $.msgBox({
                    type: "confirm",
                    content: "Are you sure want to delete data?",
                    buttons: [{ value: "Yes" }, { value: "No"}],
                    success: function (result) {
                        if (result == "Yes") {  
                            var valGrid = JSON.stringify(GridCompPriceRate.GetSelectedKeysOnPage());
                                valGrid = valGrid.replace('["','');
                                valGrid = valGrid.replace('"]',';');
                                valGrid = valGrid.replace(/","/g,';');

                                $.ajax({
                                    type: "POST",
                                    url: "@Url.Content("~/D31007/DeleteRate")",
                                    data: { 
                                            GridParam : valGrid
                                          },
                                    success: function (result) {
                                                        var resValue = result.split('|');
                                                        if (resValue[0] == 'Error')
                                                        {  
                                                            $.msgBox({
                                                               title: "Error",
                                                               type: "error",
                                                               content: resValue[1]
                                                              });
                                                        } else {
                                                            $.msgBox({
                                                                title: "Information",
                                                                type: "info",
                                                                content: resValue[1]
                                                            });
                                                            GridCompPriceRate.UnselectRows();
                                                        }
                                            },
                                     error: function (result) {
                                                var resValue = result.split('|');
                                                $.msgBox({
                                                       title: "Error",
                                                       type: "error",
                                                       content: "Error when deleting data."
                                                      });
                                     }
                                });

                        }
                    }
                });
        }
    }

    function btnSaveClick(s, e) {
        var compPrice = '';

        if (validateSave()) {
            if (buttonAction == 'N')
                compPrice = grlCompPriceOnGrid.GetValue();
            else
                compPrice = txtCompPriceRate.GetText();

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31007/SaveNewRate")",
                data: {
                    CompPrice       : compPrice,
                    ConditionRule   : txtConditionRuleOnGrid.GetText(),
                    Price           : spCompPrice.GetValue(),
                    Tax             : grlTaxOnGrid.GetValue(),
                    SavingType      : buttonAction
                },
                success: function (result) {
                    var splitResult = result.split('|');

                    if (splitResult[0] == 'Success') {
                        $.msgBox({
                            title: "Information",
                            type: "info",
                            content: splitResult[1]
                        });
                        btnCancelClick();
                    } else {
                        $.msgBox({
                            title: "Error",
                            type: "error",
                            content: splitResult[1]
                        }); 
                    }
                },
                error: function (result) {
                    $.msgBox({
                        title: "Error",
                        type: "error",
                        content: "Error when saving data."
                    });
                }
            });
        } else {
            $.msgBox({
                title: "Warning",
                content: "Please fill all necessary field !"
            });
        }
    }

    function btnCancelClick(s, e) {
        //---=== Enable button
        btnSearch.SetEnabled(true);
        btnClear.SetEnabled(true);
        btnNew.SetEnabled(true);
        btnEdit.SetEnabled(true);
        btnDelete.SetEnabled(true);
        //---=== Disable button
        btnSave.SetEnabled(false);
        btnCancel.SetEnabled(false);
        //---=== Close editor
        GridCompPriceRate.CancelEdit();
        buttonAction = '';
    }


    //---=== End button action

    //---=== Function action
    function validateSave() {
        var result = true;

        if (buttonAction == 'N') {
            if ((grlCompPriceOnGrid.GetValue() == '') || (grlCompPriceOnGrid.GetValue() == null))
            result = false;
        }

        if ((txtConditionRuleOnGrid.GetText() == '') || (txtConditionRuleOnGrid.GetText() == null))
            result = false;

        if ((spCompPrice.GetValue() == '') || (spCompPrice.GetValue() == null))
            result = false;

        return result;
    }
    //---=== End function action

</script>

<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD; padding: 10px; width: 98%; margin-right: 10px;">
    @Html.Action("PartialHeader", "D31007")
</div>
<div style="height: 10px;">
</div>

<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD; padding: 10px; width: 98%; margin-right: 10px;">
    <table width="100%" cellpadding="0" cellspacing="0" border="0" style="float: right;">
        <tr>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnSave";
                    button.Text = "Save";
                    button.Width = Unit.Pixel(80);
                    button.ClientEnabled = false;
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnSaveClick";
                }).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnCancel";
                    button.Text = "Cancel";
                    button.Width = Unit.Pixel(80);
                    button.ClientEnabled = false;
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnCancelClick";
                }).GetHtml()
            </td>
            <td style="width: 880px;">
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnNew";
                    button.Text = "Add";
                    button.Width = Unit.Pixel(80);
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnNewClick";
                }).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnEdit";
                    button.Text = "Edit";
                    button.Width = Unit.Pixel(80);
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnEditClick";
                }).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnDelete";
                    button.Text = "Delete";
                    button.Width = Unit.Pixel(80);
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnDeleteClick";
                }).GetHtml()
            </td>
        </tr>
    </table>
</div>
<br />
@Html.Action("GridCompPriceRateCallback", "D31007")

@Html.DevExpress().LoadingPanel(
    settings =>
    {
        settings.Name = "LoadingPanel";
        settings.Modal = true;
    }).GetHtml()
